﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Data.PropertyGrid;

namespace SilverlightApplication348
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            rpg.EditorTemplateSelector = new MySelector();
            rpg.Item = new Foo() { Bar1 = new Bar() { Name = "Bar1Name", Value = 42 }, Bar2 = new Bar() { Name = "Bar2Name", Value = 43 }, };
        }
    }

    public class Foo
    {
        public Bar Bar1 { get; set; }
        public Bar Bar2 { get; set; }
    }

    public class Bar
    {
        public string Name { get; set; }
        public int Value { get; set; }
    }

    public class MySelector : DataTemplateSelector
    {
        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            PropertyDefinition def = item as PropertyDefinition;
            if (def.SourceProperty.PropertyType == typeof(string))
            {
                return App.Current.Resources["nameTemplate"] as DataTemplate;
            }
            else if (def.SourceProperty.PropertyType == typeof(Int32))
            {
                return App.Current.Resources["valueTemplate"] as DataTemplate;
            }
            return null;
        }
    }
}
